<?php

namespace app\common\controller;

use app\BaseController;
use app\common\api\ChuanglanSmsApi;
use app\common\model\MessageRecord;
use app\common\model\TalentChecklog;
use think\Facade\Cache;
use app\common\validate\Enterprise;
use think\exception\ValidateException;
use think\facade\Request;
use app\common\api\UploadApi;

class Auth extends BaseController
{

    public function register(){
        $msg = "";
        if($this->request->isPost()){
            $source = intval($this->request['source']);
            $response_object = new \StdClass();
            $data = [
                'username' => \StrUtil::getRequestDecodeParam($this->request,'username'),
                'password' => \StrUtil::getRequestDecodeParam($this->request,'password'),
                're_password' => \StrUtil::getRequestDecodeParam($this->request,'re_password'),
                'name' => \StrUtil::getRequestDecodeParam($this->request,'name'),
                'idCard' => \StrUtil::getRequestDecodeParam($this->request,'idCard'),
                'agentName' => \StrUtil::getRequestDecodeParam($this->request,'agentName'),
                'agentPhone' => \StrUtil::getRequestDecodeParam($this->request,'agentPhone'),
                'verificationCode' => \StrUtil::getRequestDecodeParam($this->request,'verificationCode'),
                'legal' => \StrUtil::getRequestDecodeParam($this->request,'legal'),
                'street' => \StrUtil::getRequestDecodeParam($this->request,'street'),
                'address' => \StrUtil::getRequestDecodeParam($this->request,'address'),
                'type' => intval($this->request['type']),
                'enterpriseTag' => \StrUtil::getRequestDecodeParam($this->request,'enterpriseTag'),
                'enterpriseType' => \StrUtil::getRequestDecodeParam($this->request,'enterpriseType'),
                'agentEmail' => \StrUtil::getRequestDecodeParam($this->request,'agentEmail'),
                'ephone' => \StrUtil::getRequestDecodeParam($this->request,'ephone'),
                'industryFieldNew' => \StrUtil::getRequestDecodeParam($this->request,'industryFieldNew'),
                'industryFieldOld' => \StrUtil::getRequestDecodeParam($this->request,'industryFieldOld'),
                'bankCard' => \StrUtil::getRequestDecodeParam($this->request,'bankCard'),
                'bank' => \StrUtil::getRequestDecodeParam($this->request,'bank'),
                'bankNetwork' => \StrUtil::getRequestDecodeParam($this->request,'bankNetwork')
            ];
            try {
                $result = validate(Enterprise::class)->batch(true)->scene('add')->check($data);
                //检验验证码
                $codeResult = MessageRecord::where('smsType',1)->where('phone',$data['agentPhone'])->find();
                if(!$codeResult){
                    $response_object->code = 500;
                    $response_object->msg = '请先发送验证码';
                    return \StrUtil::back($response_object,"Register.epCallBack");
                }

                if(time() - strtotime($codeResult['createTime']) > 300){
                    $response_object->code = 500;
                    $response_object->msg = '验证码过期，请重新发送';
                    return \StrUtil::back($response_object,"Register.epCallBack");
                }
                //检验附件
                $uploadapi = new UploadApi();
                $upload_result = $uploadapi->uploadOne($this->request->file('imgurl'),'image');
                if($upload_result->code == 500){
                    return \StrUtil::back($upload_result,"Register.epCallBack");
                }
                $data['id'] = getStringId();
                $data['password'] = hash('md5',$data['password']);
                $data['source'] = $source;
                $data['imgurl'] = $upload_result->filepath;
                $data['createTime'] = date("Y-m-d H:i:s",time());
                $data['updateTime'] = date("Y-m-d H:i:s",time());
                $data['active'] = 1;
                $data['checkState'] = 1;
                \app\common\model\Enterprise::create($data);

                TalentChecklog::create([
                    'id' => getStringId(),
                    'mainId' => $data['id'],
                    'type' => 10,
                    'typeField' => null,
                    'active' => 1,
                    'state' => 1,
                    'step' => 100,
                    'stateChange' => '用户提交',
                    'description' => '用户注册',
                    'createTime' => date("Y-m-d H:i:s",time()),
                    'createUser' => '用户'
                ]);

                $response_object->code = 200;
                $response_object->msg = '注册成功';
                return \StrUtil::back($response_object,"Register.epCallBack");
            } catch (ValidateException $e){
                $error = $e->getError();
                $response_object->code = 500;
                $response_object->msg = array_pop($error);
                return \StrUtil::back($response_object,"Register.epCallBack");
            }


        }
        return view("", ["msg" => $msg]);
    }

    public function enterpriseRegister()
    {

    }

    public function verificationCode()
    {
        $phone = $this->request["phone"];
        $type = $this->request["type"];
        //校验手机号码是否为空
        if(\StrUtil::isEmpOrNull($phone)) {
            return json(["msg" => "请填写手机号码!"],500);
        }
        if (\StrUtil::isEmpOrNull($type)) {
            return json(["msg" => "请填写手机号码!"],500);
        }
        //校验手机号码格式是否正确
        if(\StrUtil::isMoblePhone($phone)) {
            return json(["msg" => "请填写正确的手机号码!"],500);
        }

        $record = Cache::get("verify_{$type}_{$phone}");

        if($record){
            $time = time();
            if($time - $record <= 60){
                return json(["msg" => "一分钟内请勿频繁发送短信!"],500);
            }
        }

        $code = '';
        for ($i = 1;$i <= 6;$i++){
            $code .= rand(0,9);
        }

        $template = "【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$code}，5分钟内有效。若非本人操作请忽略。";

        $smsapi = new ChuanglanSmsApi();

        $result = $smsapi->sendSMS($phone,$template);

        $result = json_decode($result,true);

        $id = getStringId();

        $record_data = [
            'id' => $id,
            'bizId' => $id,
            'type' => 2,
            'smsType' => 1,
            'phone' => $phone,
            'params' => $code,
            'templateCode' => $template,
            'state' => $result['code'] == 0 ? 2 : 3,
            'sendingDate' => date("Y-m-d H:i:s",time()),
            'createTime' => date("Y-m-d H:i:s",time()),
            'msg' => $result['errorMsg']
        ];

        MessageRecord::create($record_data);

        if($result['code'] == 0){
            Cache::set("verify_{$type}_{$phone}",time());
            return json(["msg" => '验证码发送成功'],200);
        }else{
            return json(["msg" => '验证码发送失败'],500);
        }
    }
}
